Subject: Re: [Idr] comments on idr-bgp4-20

From: Pekka Savola <[email-masked]>
Date: Sat, 4 Oct 2003 08:59:35 +0300 (EEST)

On Tue, 30 Sep 2003, Dennis Ferguson wrote:
> > > > It is a bug in the specification sense because the spec does not include 
> > > > text that you should do loop prevention by discarding the path when it 
> > > > contains your own AS.
> > > 
> > > The minimal theoretical requirement for loop termination (BGP doesn't
> > > prevent loops which occur transiently, just guarantees they'll eventually
> > > be stopped) is that you should discard the path when it includes your
> > > own AS `N' times, for any `N' you care to choose.  While N=1, which you like,
> > > will terminate loops, letting N=2 or N=5 or N=12 will terminate them
> > > just fine as well (though you are wasting convergence time if you make
> > > `N' larger than the number of inter-AS border routers you have, at most).
> > > It hence isn't a bug to allow `N' to be set to a value other than 1 in
> > > any theoretical sense.
> > 
> > I wouldn't call such an AS having a coherent routing plan.  If you allow 
> > AS > 1, you're abusing the term AS.
> 
> I notice you've changed the subject from one of protocol correctness, i.e.
> whether routing loops are guaranteed to terminate, to one of policy, i.e.
> whether, in your opinion, it is a good idea to do this to solve routing
> problems one might have when using the protocol.

These are invariably linked.  BGP is built on a set of assumptions (e.g.
on what it means to be an AS), and this seems to break that assumption.  
 
> As the people who originally responded to you implied, the BGP protocol
> specification has always tried to limit itself to ensuring protocol
> correctness while leaving policy to the users of the protocol.  I think
> that's still appropriate.

That's a good goal, but going too far on that path is not useful... when 
it requires changes or features in the protocol to accommodate for the 
"policies" of the users.
 
> > > > Further, there is no need to do anything of this sort if you get default 
> > > > routes from the Internet, or set up a backup (highest protocol distance) 
> > > > route towards the Internet.
> > > 
> > > I'm sure you don't mean that one or the other of those things is always
> > > possible to do.  It is when neither of those things is possible that you
> > > might want to set N>1 instead.
> > 
> > Can you shown me a couple (or at least _one_) example where other methods 
> > are not possible and this is required?
>  
> Suppose the operators of two multiply-connected networks agree to provide
> backup routing to heal each other's partitions without offering transit
> to the rest of "the Internet".  Here you need explicit routing for the
> destinations being backed up (they may already default traffic to "the
> Internet" to other providers), and you certainly can't have two guys
> pointing default routes at each other in any case.

One can use explicit static routes to each other.  Even a default route at
one end, as long as you guarantee that at least one party has the full
routing routing table, is possible.

> Or, suppose three operators have entered into a similar arrangement, with
> the partitioned guy being allowed to split his load across the other two.
> You can't have two default routes pointing at different guys (especially
> if "the Internet" is in some other direction), and you generally need
> explicit routes to get a predictable load split.

Equal cost multipathing should allow one to load-balance with a default 
route as well.  Inbound traffic would be load split more roughly.

But I don't think this is a realistic scenario.  Planning for load 
balacing during the network partition... hello?
 
> Of course these are only problems I can think of, there are likely
> lots more problems that I can't imagine.  The latter is the reason the
> BGP specification should limit itself to protocol correctness issues,
> leaving policy issues to the protocol users who actually have the
> problems to solve.

In both cases tunnels should fix the problem, and eliminate the root cause 
for this kind of behaviour.

-- 
Pekka Savola                 "You each name yourselves king, yet the
Netcore Oy                    kingdom bleeds."
Systems. Networks. Security. -- George R.R. Martin: A Clash of Kings

_______________________________________________
Idr mailing list
[email-masked]
https://www1.ietf.org/mailman/listinfo/idr

---

From: Pekka Savola <[email-masked]>
Date: Sat, 4 Oct 2003 08:59:35 +0300 (EEST)